// StegoWav - a tool for steganography on Microsoft wave files
//
// Copyright (C) 1996 by Peter Heist <heistp@rpi.edu>.  All rights reserved.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

import java.lang.*;
import java.io.*;
import java.util.*;
import WavFile;

public class LSBRandomizer
    {
    public static void main(String argv[])
    	{
    	String fileName = argv[0];
	int coverage = Integer.parseInt(argv[1]);
	double coverageDouble;
	WavFile wf;
	int bytesRead;
	short[] sampleBuffer = new short[4096];
	Random R = new Random();

	if (coverage < 0) coverage = 0;
	if (coverage > 100) coverage = 100;
	coverageDouble = (double) coverage / (double) 100.0;

	try  
	    {
	    wf = new WavFile(fileName, "rw");

	    for (long l = 0; l < wf.length(); l++)
	    	{
		wf.seek(l);
		if (R.nextDouble() < coverageDouble)
		    {
		    if (R.nextDouble() < 0.5)
		    	wf.setLSB(false);
		    else
			wf.setLSB(true);
		    }
	    	}
	    }
	catch (IOException e)
	    {
	    System.out.println("main: " + e);
	    }
	catch (BadAudioFileException e)
	    {
	    System.out.println("main: " + e);
	    }
    	}
    }
    